diff --git a/debian/patches/00list b/debian/patches/00list
index 0bae9d0..36f9a0e 100644
--- a/debian/patches/00list
+++ b/debian/patches/00list
@@ -21,3 +21,4 @@
 22-getopt.dpatch
 23-netmask-dos.dpatch
 98_patchlevel_debian
+99_tls
diff --git a/debian/patches/99_tls.dpatch b/debian/patches/99_tls.dpatch
new file mode 100644
index 0000000..06a282c
--- /dev/null
+++ b/debian/patches/99_tls.dpatch
@@ -0,0 +1,63 @@
+#! /bin/sh /usr/share/dpatch/dpatch-run
+## 99_tls.patch by Peter Wu <peter@lekensteyn.nl>
+##
+## All lines beginning with `## DP:' are a description of the patch.
+## DP: Hardens TLS configuration
+
+@DPATCH@
+diff --git a/src/ircd.c b/src/ircd.c
+index fb36b35..4441205 100644
+--- a/src/ircd.c
++++ b/src/ircd.c
+@@ -489,6 +489,37 @@ setup_corefile(void)
+ #endif
+ }
+ 
++static void
++init_ssl_dh(void)
++{
++  DH *dh;
++  /* params from nginx  */
++  static unsigned char dh1024_p[] = {
++    0xBB, 0xBC, 0x2D, 0xCA, 0xD8, 0x46, 0x74, 0x90, 0x7C, 0x43, 0xFC, 0xF5,
++    0x80, 0xE9, 0xCF, 0xDB, 0xD9, 0x58, 0xA3, 0xF5, 0x68, 0xB4, 0x2D, 0x4B,
++    0x08, 0xEE, 0xD4, 0xEB, 0x0F, 0xB3, 0x50, 0x4C, 0x6C, 0x03, 0x02, 0x76,
++    0xE7, 0x10, 0x80, 0x0C, 0x5C, 0xCB, 0xBA, 0xA8, 0x92, 0x26, 0x14, 0xC5,
++    0xBE, 0xEC, 0xA5, 0x65, 0xA5, 0xFD, 0xF1, 0xD2, 0x87, 0xA2, 0xBC, 0x04,
++    0x9B, 0xE6, 0x77, 0x80, 0x60, 0xE9, 0x1A, 0x92, 0xA7, 0x57, 0xE3, 0x04,
++    0x8F, 0x68, 0xB0, 0x76, 0xF7, 0xD3, 0x6C, 0xC8, 0xF2, 0x9B, 0xA5, 0xDF,
++    0x81, 0xDC, 0x2C, 0xA7, 0x25, 0xEC, 0xE6, 0x62, 0x70, 0xCC, 0x9A, 0x50,
++    0x35, 0xD8, 0xCE, 0xCE, 0xEF, 0x9E, 0xA0, 0x27, 0x4A, 0x63, 0xAB, 0x1E,
++    0x58, 0xFA, 0xFD, 0x49, 0x88, 0xD0, 0xF6, 0x5D, 0x14, 0x67, 0x57, 0xDA,
++    0x07, 0x1D, 0xF0, 0x45, 0xCF, 0xE1, 0x6B, 0x9B
++  };
++  static unsigned char dh1024_g[] = { 0x02 };
++
++  dh = DH_new();
++  if (!dh)
++    server_die("No dh!", 0);
++  dh->p = BN_bin2bn(dh1024_p, sizeof(dh1024_p), NULL);
++  dh->g = BN_bin2bn(dh1024_g, sizeof(dh1024_g), NULL);
++  if (!dh->p || !dh->g)
++    server_die("No p or g params!", 0);
++  SSL_CTX_set_tmp_dh(ServerInfo.ctx, dh);
++  DH_free(dh);
++}
++
+ /* init_ssl()
+  *
+  * inputs       - nothing
+@@ -513,7 +544,12 @@ init_ssl(void)
+   }
+ 
+   SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_NO_SSLv2);
+-  SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_TLS_ROLLBACK_BUG|SSL_OP_ALL);
++  SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_NO_SSLv3);         /* POODLE */
++  SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_NO_TLSv1);         /* BEAST */
++  SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_NO_COMPRESSION);   /* CRIME */
++  SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_ALL);
++  SSL_CTX_set_cipher_list(ServerInfo.ctx, "EECDH+AESGCM");
++  init_ssl_dh();
+   SSL_CTX_set_verify(ServerInfo.ctx, SSL_VERIFY_NONE, NULL);
+ 
+   bio_spare_fd = save_spare_fd("SSL private key validation");
